/*
Country

Hello, I'm general purpose object "Country".

I'm a simple model of a country.

I have:
	name
	aveTemperature (F)
	capital
	populationDensity (persons/square-mile)
*/

public class Country
{
	//===========================================================
	//Instance Variables

	private String name;
	private int aveTemperature;			//Fahrenheit (F)
	private String capital;
	private int populationDensity;		//persons/square-mile

	//===========================================================
	//Constructors

	public Country(String aName, int aAveTemperature,
						String aCapital, int aPopulationDensity)
	{
		this.name = aName;
		this.aveTemperature	 = aAveTemperature;
		this.capital = aCapital;
		this.populationDensity = aPopulationDensity;
	}

	//===========================================================
	//Getters

	public String getName() { return this.name; }
	public int getAveTemperature() { return this.aveTemperature; }
	public String getCapital() { return this.capital; }
	public int getPopulationDensity() { return this.populationDensity; }

	//===========================================================
	//Basic

	public String toString()
	{
		//format our string in fixed size columns for friendly row comparison format
		String t, pop;
		//first convert ints to strings
		t = String.valueOf(this.getAveTemperature());
		pop = String.valueOf(this.getPopulationDensity());
		//give fields fixed widths
		return String.format("%-20s %-20s %-20s %-20s", this.getName(), t, this.getCapital(), pop);
	}

	public static String fieldLabelsFormatted()
	{
		return String.format("%-20s %-20s %-20s %-20s",
								"Country Name", "Ave Temp (F)", "Capital", "Population (/SqMi)");
	}

	//===========================================================
	//Instance Methods

	public int getAveTemperatureAsCelsius ()
	{
		//C = (F - 32) * (5/9)
		double c = (this.aveTemperature - 32.0) * (5.0 / 9.0);
		return (int) Math.round(c);
	}


}
